package wtalk.protocols.irc;

import java.io.*;
import java.net.*;


import wtalk.RMsgHandler;

class ReceivedListener extends Thread{
	private BufferedReader in=null;
	private RMsgHandler rmh=null;	// generic message handler
	private RMsgHandler rwh = null;	// handles wall messages if !null
	private RMsgHandler rsh = null;	// handles system messages if !null
	private RMsgHandler rph = null;	// handles private messages if !null
	private StatusListener sl = null; //listens for status resposnes

	public ReceivedListener(){
		in = null; rmh = null;
	}

	public void ListenTo(BufferedReader n){
		in = n;
	}

	public void ReportTo(RMsgHandler r){
		rmh = r;
	}

	public void ReportWallTo(RMsgHandler r){
		rwh = r;
	}

	public void ReportSystemTo(RMsgHandler r){
		rsh = r;
	}

	public void ReportPrivateTo(RMsgHandler r){
		rph = r;
	}

	public void setStatusListener(StatusListener s){
		sl = s;
	}

	public void run(){
		String s;
		String target, from, data;
		IRCMessage message=null;

		if(in==null) return;

		while(true){

			try{
				s = in.readLine();
			} catch(IOException e){ return; }


			if(s==null) break;

			message = new IRCMessage(s);
			target = message.getReceiver();
			from = message.getSender();
			data = message.getText();

			if(target.equals("")){
				rsh.handle(target, from, data);
			} else if(!(target.charAt(0)=='&' || 
					target.charAt(0)=='#')) {
				rph.handle(target, from, data);
			} else {
				rmh.handle(target, from, data);
			}

			
		}

		in=null;

	}
}

